<div class="paf-container">
<app-spinner [show]="loading"></app-spinner>
    <div class="control-container" [formGroup]="formGroup">

        <div class="d-flex">

            <div class="flex-fill" style="margin-right: 10px;">
                <div class="w-100 text-right">
                    <mat-hint align="end" class="required-hint">Required</mat-hint>
                </div>
                <mat-form-field [appearance]="appearance">
                    <mat-label>Speciality</mat-label>
                    <app-dropdown-search [data]="specialities"
                                         valueField="id"
                                         textField="specialityName"
                                         formControlName="specialityId"
                                         (valueChange)="onSelectionChange(CTRL_SPECIALITY)"
                    ></app-dropdown-search>
                    <mat-error *ngIf="formGroup.get('specialityId').hasError('required')">
                        This field is required
                    </mat-error>
                </mat-form-field>
            </div>

            <div class="flex-fill" style="margin-left: 10px;">
                <div class="w-100 text-right">
                    <mat-hint align="end" class="required-hint">Required</mat-hint>
                </div>
                <mat-form-field [appearance]="appearance">
                    <mat-label>Practitioner</mat-label>
                    <app-dropdown-search [data]="practitionersFiltered"
                                         valueField="practitionerId"
                                         textField="nickName"
                                         formControlName="practitionerId"
                                         (valueChange)="onSelectionChange()"
                    ></app-dropdown-search>
                    <mat-error *ngIf="formGroup.get('practitionerId').hasError('required')">
                        This field is required
                    </mat-error>
                </mat-form-field>
            </div>

        </div>

        <div class="d-flex">

            <div class="w-50" style="padding-right: 10px;">
                <div class="w-100 text-right">
                    <mat-hint align="end" class="required-hint">Required</mat-hint>
                </div>
                <mat-form-field [appearance]="appearance">
                    <mat-label>Duration</mat-label>
                    <app-dropdown-search [data]="slots"
                                         valueField="value"
                                         textField="text"
                                         formControlName="slot"
                                         (valueChange)="onSelectionChange()"
                    ></app-dropdown-search>
                    <mat-error *ngIf="formGroup.get('slot').hasError('required')">
                        This field is required
                    </mat-error>
                </mat-form-field>
            </div>

            <div class="flex-fill" style="margin-left: 10px;">

            </div>

        </div>

    </div>

    <div class="calender-container">

        <div class="cal-header d-flex align-items-center justify-content-center">
            <div class="d-flex align-items-center">
                <button class="date-picker-pn-btn" [disabled]="currentMonth === thisMonth" (click)="nextPrevDate(-1)">
                    <mat-icon class="pn-icon">keyboard_arrow_left</mat-icon>
                </button>

                <button #monthPicker class="d-flex align-items-center selected-date-wrapper">
                    <div class="text-center flex-fill">
                        {{month}}, {{currentYear}}
                    </div>
                    <app-calender-popup [anchor]="monthPicker" [maxZoomLevel]="'year'" [value]="currentDate" (valueChange)="dateChange($event)"></app-calender-popup>
                </button>
                <button class="date-picker-pn-btn" (click)="nextPrevDate(1)">
                    <mat-icon class="pn-icon">keyboard_arrow_right</mat-icon>
                </button>
            </div>
        </div>

        <div class="cal-body">

            <div *ngIf="errorMsg" class="selection-message-container d-flex align-items-center justify-content-center">
                {{errorMsg}}
            </div>

            <div *ngIf="!errorMsg" class="days-names-container d-flex justify-content-center">

                <div class="day-name d-flex align-items-center justify-content-center" *ngFor="let day of days">
                    {{day.substr(0, 1)}}
                </div>

            </div>

            <div *ngIf="!errorMsg" class="date-cells d-flex flex-wrap justify-content-center" style="margin-top: 14px;">
                <ng-container *ngFor="let date of dates; let i = index">
                    <div
                            class="date-cell d-flex align-items-center justify-content-center"
                            [class.have-date]="date !== null && (date.morningTimes || date.eveningTimes || date.afterNoonTimes)"
                            [class.clicked-cell]="date !== null && clickedCellIndex == i"
                            (click)="clickDateCell(i, date)"
                    >
                        <div class="d-flex flex-column justify-content-center align-items-center"
                             *ngIf="date && (date.morningTimes || date.eveningTimes || date.afterNoonTimes)">
                            <span>{{date.date | timeFormat: 'D'}}</span>

                            <div class="d-flex">
                                <div class="time-indicator m"
                                     *ngIf="date.morningTimes && date.morningTimes.length > 0"></div>
                                <div class="time-indicator a"
                                     *ngIf="date.afterNoonTimes && date.afterNoonTimes.length > 0"></div>
                                <div class="time-indicator e"
                                     *ngIf="date.eveningTimes && date.eveningTimes.length > 0"></div>
                            </div>
                        </div>
                    </div>

                    <div *ngIf="i !== 0 && (i + 1) % 7 === 0"
                         [class.d-flex]="clickedCell && clickedCellIndex >= (((i+1)/7) - 1) * 7 && clickedCellIndex <= i"
                         [attr.index]="(((i+1)/7) - 1) * 7"
                         class="date-cell d-none align-items-center extra have-date {{'index-'+i}}"
                         style="width: 100%;
                                height: auto;
                                margin: -16px 2px 15px 2px;
                                padding-top: 10px;
                                cursor: unset;
                                z-index: 1;"
                         [style.border-top-right-radius.px]="(clickedCellIndex + 1) % 7 === 0 ? '0' : '4'"
                         [style.border-top-left-radius.px]="(clickedCellIndex + 1) % 7 === 1 ? '0' : '4'"
                    >

                        <div *ngIf="clickedCell && clickedCellIndex > -1">
                            <div class="d-flex flex-wrap">
                                <span *ngFor="let time of clickedCell.morningTimes"
                                      class="time-indicator m d-flex align-items-center justify-content-center"
                                      style="width: 66px; height: 20px; border-radius: 4px; color: white; margin: 0 10px 10px 10px; cursor: pointer;"
                                      (click)="bookAppointment(time, $event)"
                                >
                                    {{time.time}}
                                </span>
                            </div>
                            <div class="d-flex flex-wrap">
                                <span *ngFor="let time of clickedCell.afterNoonTimes"
                                      class="time-indicator a d-flex align-items-center justify-content-center"
                                      style="width: 66px; height: 20px; border-radius: 4px; color: white; margin: 0 10px 10px 10px; cursor: pointer;"
                                      (click)="bookAppointment(time, $event)"
                                >
                                    {{time.time}}
                                </span>
                            </div>
                            <div class="d-flex flex-wrap">
                                <span *ngFor="let time of clickedCell.eveningTimes"
                                      class="time-indicator e d-flex align-items-center justify-content-center"
                                      style="width: 66px; height: 20px; border-radius: 4px; color: white; margin: 0 10px 10px 10px; cursor: pointer;"
                                      (click)="bookAppointment(time, $event)"
                                >
                                    {{time.time}}
                                </span>
                            </div>
                        </div>

                    </div>
                </ng-container>
            </div>

        </div>
    </div>

    <div *ngIf="!errorMsg" class="d-flex justify-content-center" style="margin-top: 20px;">
        <div class="d-flex align-items-center">
            <div class="time-indicator big m"></div>
            <span style="margin-left: 10px;">Morning</span>
        </div>
        <div class="d-flex align-items-center" style="margin-left: 23px;">
            <div class="time-indicator big a"></div>
            <span style="margin-left: 10px;">Afternoon</span>
        </div>
        <div class="d-flex align-items-center" style="margin-left: 23px;">
            <div class="time-indicator big e"></div>
            <span style="margin-left: 10px;">Evening</span>
        </div>
    </div>

</div>


<dx-popover
    #practitionerSelectPopup
    class="pttr-select-popup"
    [width]="200"
    [height]="'auto'"
    [minHeight]="44"
    [shading]="false"
    (onHiding)="autoAdjust()"
>
    <div *dxTemplate="let data = model; of: 'content'">
        <mat-form-field [appearance]="appearance" class="no-pm-field">
            <mat-label>Select a Practitioner</mat-label>
            <app-dropdown-search [data]="availablePractitioners"
                                 valueField="practitionerId"
                                 textField="practitionerName"
                                 (valueChange)="onSelectPractitioner($event)"
            ></app-dropdown-search>
        </mat-form-field>
    </div>
</dx-popover>
